/*
 * bqfv.m.c
 * Copyright (C) 2009-2012, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <bcount.h>
#include <bqfx-defs.h>
#include <bqfx-inter.h>
#include <bqfx-lines.h>
#include <bqfx-names.h>
#include <bqfx-types.h>
#include <reverse.h>
#include <xfs.h>

#define __HALF_TRANSFER__		1

#define __LOSE_DOUBLE__			1

#define __LOSE_METHOD__			__LOSE_DOUBLE__

#define __UNROLL_TRANSFER__		0

#define here_two_test(___h) \
    ((___h) & 8192)

#undef here_two_test

#if __LOSE_METHOD__ == __LOSE_DOUBLE__
# define here_two_n_count(___h, ___e) \
    ___n = (___e) & ~Lx55555555;					      \
    ___p |= (___n | ___n << (half_integral_q_bits - 1))			      \
	& ~Q(0) << half_integral_q_bits;				      \
    if (1) {								      \
	___t |= Q(1024) << half_integral_q_bits;			      \
    }
#endif				/* __LOSE_METHOD__ == __LOSE_DOUBLE__ */

#if __LOSE_METHOD__ == __LOSE_DOUBLE__
# define here_two_l_reset(___h) \
    ___p = 0;								      \
    ___t = 0
#endif				/* __LOSE_METHOD__ == __LOSE_DOUBLE__ */

#if __LOSE_METHOD__ == __LOSE_DOUBLE__
# define here_two_declarations \
    integral_q ___n, ___p, ___t
#endif				/* __LOSE_METHOD__ == __LOSE_DOUBLE__ */

#if __LOSE_METHOD__ == __LOSE_DOUBLE__
# define here_two_setup(___f, ___g) \
    l2_q_heap_1up(___p);						      \
									      \
    ___p &= Q(0xff) | Q(0xff) << half_integral_q_bits;			      \
									      \
    ___p |= ___t;							      \
    ___p |=								      \
	((___p								      \
	  - ((___t & (Q(1024) | Q(1024) << half_integral_q_bits)) >> 10))     \
	 & (Q(1024) | Q(1024) << half_integral_q_bits)) << 3;		      \
									      \
    (___g) = ___p >> half_integral_q_bits
#endif				/* __LOSE_METHOD__ == __LOSE_DOUBLE__ */

#define here_two_test(___h) \
    ((___h) & 8192)

#define beta(___s, ___n) \
    (___s) = (char *) (___s) - ((___n) << 1)

#define cell(___s, ___n, ___t) \
    ((char *) (___s) - (___n) * (___t))

#define dana(___s, ___n) \
    (___s) = (char *) (___s) + ((___n) << 1)

#define life(___s, ___n) \
    ((char *) (___s) - (___n))

#define posh(___s, ___n) \
    (___s) = (char *) (___s) - (___n)

#define road(___s, ___n) \
    ((char *) (___s) + ((___n) << 1))

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#define sans(___s, ___n) \
    ((char *) (___s) + (___n))

#define skip(___s, ___n) \
    (___s) = (char *) (___s) + (___n)

#define trap(___n, ___s)		((___n) + ((___s) << 2))

#define true(e)				1

#undef Q
#define Q(e)				((integral_q) (e))

#define bqfset(bqfset)			((struct bqfset_type *) (bqfset))

static int edge(void *, unsigned, unsigned, int (*)(void *, void *, unsigned));

static int
edge(void *node, unsigned size, unsigned call,
     int (*move)(void *, void *, unsigned))
{
    integral_q news, slip;

    news = *(integral_q *) node;

    slip = news & ~Lx55555555;

    {
	if (1) {
	    call++;

	    if (call & 1) {
		*(integral_q *) node = news & ~(Q(1) << call);
	    } else {
		if (news & (Q(1) << (call - 1))) {
		    *(integral_q *) node = news & ~(Q(1) << (call - 1));
		    if (2) {
			void *data, **text;

			data = HD(node, size, call);
			move(data, life(data, size), 1);
			call--;
			text = ZD(node, size) + call;
			*text = *(text - 1);
		    }
		} else {
		    if (news & (Q(1) << (call + 1))) {
			void *data, **text;

			*(integral_q *) node = news & ~(Q(1) << (call + 1));
			data = HD(node, size, call);
			move(data, sans(data, size), 1);
			text = ZD(node, size) + call;
			*(text - 1) = *text;
		    } else {
			integral_q back;
			unsigned deck, ever;

			back = slip & (~Q(0) << call);
			if (1) {
			    l2_q_xfs(ever, back);
			    if (0) {
			    } else {
				if (2) {
				    void *data, **text;

				    *(integral_q *) node =
					news & ~(Q(1) << ever);
				    deck = (ever - call) >> 1;
				    call--;
				    text = ZD(node, size) + call;
				    call++;
				    data = rule(node, size, call);
				    for (; deck; deck--) {
					void *trip;

					*text = *(text + 2);
					text += 2;
					trip = road(data, size);
					move(data, trip, 1);
					data = trip;
				    }
				    {
					*text = *(text + 1);
					move(data, sans(data, size), 1);
				    }
				}
			    }
			}
		    }
		}
	    }
	}
    }

    return 0;
}


int
_libx1f4l2_neon_bqfset(void *bqfset, void *node, integral_q pipe)
{
    int (*move)(void *, void *, unsigned), status;
    integral_q next;
    unsigned dash, deck, ever, size;
    void *file, *past, *tier;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    move = bqfset(bqfset)->link_f.move;

    dash = ~pipe >> 1 & 1;

    file = ZD(node, size)[dash];

    if (dash) {
	if (1) {
	    past = HD(node, size, 2);
	    if (pipe & Q(8)) {
		tier = ZD(node, size)[2];
	    } else {
		tier = ZD(node, size)[3];
	    }
	}
    } else {
	past = HD(node, size, 1);
	if (0) {
	} else {
	    {
		tier = ZD(node, size)[1];
	    }
	}
    }

    status = 0;

    {
	here_two_declarations;

	if (0) {
	} else {
	    here_two_l_reset(deck);
	}

	if (1) {
	    next = *(integral_q *) tier;
	    here_two_n_count(ever, next);
	} else {
	}

	here_two_setup(deck, ever);
    }

    if (here_two_test(ever)) {
	if (1) {
#if __HALF_TRANSFER__
	    if (1) {
		integral_q text;
		unsigned slip;
		void *fast, *side;

		fast = rule(file, size, 2);

		deck = (integral_q_bits - 4) >> 1;

# if __UNROLL_TRANSFER__
#  error
# else
		if (deck & 1) {
		    side = road(fast, size);
		    move(fast, side, 1);
		    fast = side;
		}
		deck >>= 1;
		for (; deck; deck--) {
		    side = road(fast, size);
		    move(fast, side, 1);
		    fast = road(side, size);
		    move(side, fast, 1);
		}
# endif				/* __UNROLL_TRANSFER__ */

		fast = file;

		ever &= 254;

		if (ever < 4) {
		    ever = 1;

		    *(integral_q *) fast = Lx55555555;

		    fast = rule(fast, size, integral_q_bits - 2);
		} else {
		    *(integral_q *) fast = Lx55555555
			| ~Q(0) << (integral_q_bits - ever + 2);

		    if (ever < 8) {
			ever >>= 1;

			fast = rule(fast, size, integral_q_bits - ever);
		    } else {
			fast = rule(fast, size, integral_q_bits - ever + 3);

			side = sans(fast, size);

			ever >>= 1;

			deck = ever - 3;
			for (; deck; deck--) {
			    move(fast, side, 1);
			    dana(side, size);
			    skip(fast, size);
			}
		    }
		}

		move(fast, past, 1);

		skip(fast, size);

		ever--;

		side = tier;

		text = *(integral_q *) tier;

		while (ever & ~1) {
		    if (text & Q(2)) {
			skip(side, size);
			move(fast, side, 2);
			dana(fast, size);
			skip(side, size);

			ever -= 2;
		    } else {
			ever--;

			dana(side, size);
			move(fast, side, 1);
			skip(fast, size);
		    }

		    text >>= 2;
		}
		if (ever) {
		    if (text & Q(2)) {
			skip(side, size);
			move(fast, side, 1);
			skip(side, size);
			move(past, side, 1);

			ever = 0;
		    } else {
			dana(side, size);
			move(fast, side, 1);
		    }

		    text >>= 2;
		} else {
		    ever = 1;
		}
		slip = 2;
		if (ever) {
		    if (text & Q(2)) {
			skip(side, size);
			move(past, side, 1);

			skip(side, size);

			fast = road(tier, size);

			text >>= 1;
		    } else {
			dana(side, size);
			move(past, side, 1);

			skip(side, size);

			fast = road(tier, size);

			text >>= 2;

			if (fast < side) {
			    text >>= 1;
			    if (text & Q(1)) {
				move(fast, side, 1);
				dana(fast, size);
				slip += 2;
			    } else {
			    }

			    skip(side, size);
			}
		    }
		} else {
		    skip(side, size);

		    fast = road(tier, size);

		    if (fast < side) {
			text >>= 1;
			if (text & Q(1)) {
			    move(fast, side, 1);
			    dana(fast, size);
			    slip += 2;
			} else {
			}

			skip(side, size);
		    }
		}
		while (fast < side) {
		    if (text & Q(4)) {
			move(fast, side, 1);
			dana(fast, size);
			skip(side, size);
			move(fast, side, 1);
			dana(fast, size);
			skip(side, size);
			slip += 4;
		    } else {
			move(fast, side, 1);
			dana(fast, size);
			dana(side, size);
			slip += 2;
		    }

		    text >>= 2;
		}

		*(integral_q *) tier =
		    Lx55555555 | text >> 1 << (slip - 1) << 1;
	    }
#else
# error
#endif				/* __HALF_TRANSFER__ */
	}
    } else {
	do {
	    void *club = NULL, *fast, *head;

	    if (1) {
		if (0) {
		} else {
		    unsigned copy = 2;

		    head = past;

		    _libx1f4l2_four_bqfset
			(bqfset, 0, &club, pipe, &node, &dash,
			 &file, &past, &tier, next, &copy);
		    if (club) {
		    } else {
			break;
		    }
		}
	    } else {
	    }

	    {
		void *side;

		fast = club;

		*(integral_q *) club = Lxdddddddd ^ Q(1) << integral_q_last;

		if (0) {
		} else {
		    fast = rule(fast, size, 4);

		    side = life(fast, size);

		    move(side, fast, 1);
		    dana(fast, size);
		    skip(side, size);
		}

		deck = (integral_q_bits - 6) / 6;
		for (; deck; deck--) {
		    move(side, fast, 1);
		    dana(fast, size);
		    dana(side, size);
		    move(side, fast, 1);
		    dana(fast, size);
		    skip(side, size);
		    move(side, fast, 1);
		    dana(fast, size);
		    skip(side, size);
		}

		if (0) {
		} else {
		    if (half_integral_q_bits % 3 ^ 2) {
			move(side, fast, 1);

			fast = rule(file, size, 4);

			dana(side, size);
			move(side, head, 1);
			skip(side, size);
			move(side, fast, 1);
			skip(side, size);
		    } else {
			move(side, fast, 1);
			dana(fast, size);
			dana(side, size);
			move(side, fast, 1);

			fast = road(file, size);

			skip(side, size);
			move(side, head, 1);
			skip(side, size);
		    }
		}

		deck = integral_q_bits / 4 - integral_q_bits / 6 - 2;
		for (; deck; deck--) {
		    dana(fast, size);
		    move(side, fast, 1);
		    dana(side, size);
		    dana(fast, size);
		    move(side, fast, 1);
		    skip(side, size);
		    dana(fast, size);
		    move(side, fast, 1);
		    skip(side, size);
		}

		{
		    dana(fast, size);
		    move(side, fast, 1);
		    dana(side, size);
		    dana(fast, size);
		    move(side, fast, 1);
		}

		fast = rule(tier, size, integral_q_bits);

		side = fast;

		deck = integral_q_bits / 6;
		for (; deck; deck--) {
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    beta(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		}

		if (0) {
		} else {
		    if (half_integral_q_bits % 3 ^ 2) {
			fast = rule(file, size, integral_q_bits - 2);

			posh(side, size);
			move(side, past, 1);
			posh(side, size);
			move(side, fast, 1);
			beta(side, size);
			beta(fast, size);
			move(side, fast, 1);
		    } else {
			posh(side, size);
			beta(fast, size);
			move(side, fast, 1);

			fast = rule(file, size, integral_q_bits - 2);

			posh(side, size);
			move(side, past, 1);
			beta(side, size);
			move(side, fast, 1);
		    }
		}

		deck = integral_q_bits / 4 - integral_q_bits / 6 - 2;
		for (; deck; deck--) {
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    beta(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		}

		{
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		}

		*(integral_q *) tier = Lxdddddddd;
	    }

	    if (1) {
		int excess;

		move(head, cell(fast, size, 2), 1);

		status = edge(node, size, dash, move);

		excess = bqfset(bqfset)->link_m.free
		    (bqfset(bqfset)->link_m.data, file);
		if (excess) {
		    status = FREE_ERROR;
		}
	    } else {
	    }
	} while (0);
    }

    return status;
}
