/*
 * c1-inter.h
 * Copyright (C) 2006-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_c1_INTER_H__
#define __LIBx1f4_c1_INTER_H__

#include <c1-types.h>
#include <e4.h>

extern int _x1f4_c1_080707_error_0(void *, const char *);
extern int _x1f4_c1_080707_error_1(void *, const char *);
extern int _x1f4_c1_080707_error_2(void *, const char *);
extern int _x1f4_c1_080707_error_3(void *, const char *);
extern int _x1f4_c1_080707_error_4(void *, const char *);
extern int _x1f4_c1_080707_error_5(void *, const char *);
extern int _x1f4_c1_080707_error_6(void *, const char *, unsigned);
extern int _x1f4_c1_080707_error_7(void *, const char *);
extern int _x1f4_c1_080707_error_8(void *, const char *);
extern int _x1f4_c1_080707_error_9(void *, const char *);
extern int _x1f4_c1_080707_error_a(void *, const char *);
extern int _x1f4_c1_080707_error_b(void *, const char *, unsigned);
extern int _x1f4_c1_080707_error_c(void *, const char *);
extern int _x1f4_c1_080707_error_d(void *, const char *);
extern int _x1f4_c1_080707_error_e(void *, const char *, int, int);
extern int _x1f4_c1_080707_error_f(void *);
extern int _x1f4_c1_090828_error_0(void *, const char *);
extern int _x1f4_c1_090828_error_1(void *, const char *);
extern int _x1f4_c1_091025_error_0(void *, const char *, int);
extern int _x1f4_c1_110725_error_0(void *, const char *, int);
extern int _x1f4_c1_111221_error_0(void *, const char *, int);
extern int _x1f4_c1_120115_error_0(void *, const char *);
extern int _x1f4_c1_130608_error_0(void *, const char *, int);
extern int _x1f4_c1_170722_error_0(void *, const char *);
extern int _x1f4_c1_170722_error_1(void *, const char *);
extern int _x1f4_c1_170722_error_2(void *, const char *);
extern int _x1f4_c1_170722_error_3(void *, const char *);
extern int _x1f4_c1_170722_error_4(void *, const char *);
extern int _x1f4_c1_170722_error_5(void *, const char *, unsigned);
extern int _x1f4_c1_170722_error_6(void *, const char *, unsigned, int, int);
extern int _x1f4_c1_170722_error_7
    (void *, const char *, unsigned, int, int, int);
extern int _x1f4_c1_170731_error_0(void *, const char *, int);
extern int _x1f4_c1_180102_error_0(void *, const char *, unsigned);
extern int _x1f4_c1_180501_error_0(void *, const char *);
extern int _x1f4_c1_180601_error_0(void *, const char *, unsigned);
extern int _x1f4_c1_fit_trans(void *);
extern int _x1f4_c1_flat_mine(struct c1_program_type *, void *);
extern int _x1f4_c1_link_mine(struct c1_program_type *, void **);
extern int _x1f4_c1_long_note
    (struct c1_program_type *, struct c1_node_type *, int *, void *,
     int (*)(void *), int);
extern int _x1f4_c1_miss_fast(struct c1_program_type *, struct c1_fast_type *);
extern int _x1f4_c1_miss_port(struct c1_trans19_type *);
extern int _x1f4_c1_note_miss(void *, struct c1_miss_type *);
extern int _x1f4_c1_post_call(void *, void *, void *);
extern int _x1f4_c1_post_cast(void *, void *, void *);
extern int _x1f4_c1_post_lead(void *, void *, void *);
extern int _x1f4_c1_post_text(void *, void *, void *);
extern int _x1f4_c1_print_level
    (void *, int (*)(void *, const char *, unsigned), unsigned);
extern int _x1f4_c1_select_variable
    (const char *, unsigned, const void *, const struct x1f4_variable_type **,
     void **);
extern int _x1f4_c1_stat_case(void *, int);
extern int _x1f4_c1_stat_free(void *);
extern int _x1f4_c1_stat_link(void *);
extern int _x1f4_c1_stat_miss(void *);
extern int x1f4_east_program
    (struct c1_program_type *, void *, void **);
extern int x1f4_head_program(struct c1_program_type *);
extern int x1f4_inIt_program
    (struct c1_program_type **, const char **, unsigned,
     const struct c1_context_type *);
extern int x1f4_lame_program
    (void *, int (*)(void *, const char *, unsigned), const char *, unsigned,
     struct c1_back_type *, struct x1f4_eelookup_type *);
extern int x1f4_lead_program
    (struct c1_program_type *, void **);
extern int x1f4_lift_program
    (struct c1_program_type *, int *, void *, int (*)(void *), void *,
     void **);
extern int x1f4_list_program
    (void *, void *, int (*)(void *, struct c1_node_type *));
extern int x1f4_mind_program
    (void *, void *);
extern int x1f4_nice_program
    (struct c1_program_type *, int *, void *, int (*)(void *), void **);
extern int x1f4_pull_program
    (void *, void *);
extern int x1f4_push_variable
    (void **, const char *, unsigned, int, unsigned, void *);
extern int x1f4_slip_program(struct c1_program_type *);
extern int x1f4_tail_program(struct c1_program_type *);

extern void _x1f4_c1_hook_node(void *, struct c1_node_type *);

#endif				/* __LIBx1f4_c1_INTER_H__ */
