/*
 * c1.m.c
 * Copyright (C) 2006-2009, 2013, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <c1-defs.h>
#include <c1-types.h>

int
x1f4_look_program(struct c1_program_type *program_data, unsigned *line)
{
    do {
	struct c1_node_type *node_data;

	node_data = program_data->slip;
	if (node_data) {
	} else {
	    /*
	     * sort of stupid, but this function may be called for errors after
	     * the proper program execution has completed.
	     */
	    node_data = program_data->node;
	    if (node_data) {
		struct c1_node_type *node_text;

		node_text = node_data->node_data;
		while (node_text) {
		    node_data = node_text;
		    node_text = node_data->node_data;
		}
	    } else {
		break;
	    }
	}

	*line = node_data->state & LINE_COPY;
    } while (0);

    return 0;
}
