/*
 * e4-e.1-l.n.1.c
 * Copyright (C) 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4-defs.h>
#include <e4-draft.h>
#include <e4-inter.h>
#include <e4-types.h>
#include <mxdeck.h>

#define offset			sizeof(struct e4_base_type)

int
_x1f4_e4_line_cn_1(x1f4_e4_TRIP_ARGS_1)
{
    if (aile->bits & FPDECK_TRAP) {
	struct e4_atom_type *atom_data;
	unsigned i;

	atom_data = hack_data->atom_data;
	i = hack_data->count;
	while (i) {
	    if (atom_data->type == LAST) {
		struct e4_hack_type *hack_slip;
		const struct e4_last_type *last_data;

		hack_slip = atom_data->data.last.base;
		last_data = hack_base(hack_slip)->last_data;
		if (last_data->bits & XSET_LINK) {
		    hack_slip++;
		    if (hack_slip->count == 1) {
			struct e4_atom_type *atom_text;

			atom_text = hack_slip->atom_data;
			if (atom_text->type == LAST && !atom_text->odb1) {
			    struct e4_hack_type *hack_text;
			    struct e4_base_type *base_data;
			    const struct e4_last_type *last_text;
			    const void *f1st;

			    hack_text = atom_text->data.last.base;
			    base_data = hack_base(hack_text);
			    last_text = base_data->last_data;
			    if (x1f4_find_mxpath
				(aile->fpdeck, last_text->name,
				 last_text->size, &f1st)) {
				const struct e4_1stf_type *f1st_data;

				f1st_data = f1st;
				if (f1st_data->bits1 & XSET_LIST) {
				    int ftaa, type;
				    const struct e4_ftaa_type *ftaa_data;

				    type = last_data->type;

				    ftaa_data = f1st_data->ftaa_data;
				    ftaa = ftaa_data->type;
				    while (ftaa != VOID) {
					if (ftaa == type) {
					    break;
					} else {
					    ftaa_data++;
					    ftaa = ftaa_data->type;
					}
				    }
				    if (ftaa != VOID) {
#define BACK_HACK(count, excess) \
    (offset + (count) * sizeof(struct e4_hack_type))
#define LAND_HACK(count) \
    ((count) * sizeof(struct e4_hack_type))

					const struct e4_line_type *line_data;
					unsigned size;
					void *base, *data;

					size = last_text->count;

					data = aile->m.data;

					base = base_data;
					if (aile->m.mode
					    (data, &base,
					     BACK_HACK(size + 1, 0))) {
					    break;
					}

					hack_text = (struct e4_hack_type *)
					    ((char *) base + offset);

					atom_text->data.last.base = hack_text;

					atom_text->odb1 = atom_data->odb1;
					atom_text->odb2._2nd =
					    atom_data->odb2._2nd;

					*atom_data = *atom_text;

					line_data = ftaa_data->line_data;

					last_data = &line_data->last;

					base_data = base;
					base_data->last_data = last_data;
					base_data->text =
					    (void *) line_data->text;

					memmove(hack_text + 1, hack_text,
						LAND_HACK(size));

					hack_slip--;

					*hack_text = *hack_slip;

					if (last_data->bits & TEXT_LINK) {
					    _x1f4_e4_link_laSt(atom_data);
					} else {
					    _x1f4_e4_link_last(atom_data);
					}

					aile->m.free(data, atom_text);
					aile->m.free
					    (data, hack_base(hack_slip));

					*progress |= STAGE_1;

#undef LAND_HACK
#undef BACK_HACK
				    }
				}
			    }
			}
		    }
		}
	    }

	    i--;
	    atom_data++;
	}
    }

    return 0;
}
