/*
 * e4-e.1-l.n.2.c
 * Copyright (C) 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4-defs.h>
#include <e4-draft.h>
#include <e4-inter.h>
#include <e4-types.h>
#include <mxdeck.h>

#define offset			sizeof(struct e4_base_type)

int
_x1f4_e4_line_cn_2(x1f4_e4_TRIP_ARGS_1)
{
    if (aile->bits & FPDECK_TRAP) {
	struct e4_atom_type *atom_data;
	unsigned i;

	atom_data = hack_data->atom_data;
	i = hack_data->count;
	while (i) {
	    if (atom_data->type == LAST) {
		struct e4_hack_type *hack_slip;
		const struct e4_last_type *last_data;

		hack_slip = atom_data->data.last.base;
		last_data = hack_base(hack_slip)->last_data;
		if (last_data->bits & TYPE_LINK && hack_slip->count == 1) {
		    struct e4_atom_type *atom_text;

		    atom_text = hack_slip->atom_data;
		    if (atom_text->type == LOCK && !atom_text->odb1) {
			int type;
			const struct e4_ever_type *ever_data;
			struct e4_fine_type *fine_data;
			struct e4_hack_type *hack_text;
			const struct e4_last_type *last_text;
			unsigned fare;

			hack_text = atom_text->data.last.base;
			last_text = hack_base(hack_text)->last_data;

			fine_data = hack_fine(hack_text);

			type = last_data->type;

			fare = last_text->count;

			ever_data = fine_data->ever_data;
			if (ever_data->bits & FLAT_LINK) {
			    const void *f1st;

			    if (x1f4_find_mxpath
				(aile->fpdeck, last_text->name,
				 last_text->size, &f1st)) {
				const struct e4_1stf_type *f1st_data;

				f1st_data = f1st;

				if (f1st_data->bits1 & EVER_LIST) {
				    if (type ^ last_text->args[fare - 1]) {
					type = VOID;
				    }
				} else {
				    if (f1st_data->bits1 & LEAD_LIST) {
					if (type ^ last_text->args[0]) {
					    type = VOID;
					}
				    } else {
					type = VOID;
				    }
				}

				if (type != VOID) {
				    int ftsl;
				    const struct e4_ftsl_type *ftsl_data;

				    ftsl_data = f1st_data->ftsl_data;
				    ftsl = ftsl_data->type;
				    while (ftsl != VOID) {
					if (ftsl == type) {
					    break;
					} else {
					    ftsl_data++;
					    ftsl = ftsl_data->type;
					}
				    }
				    if (ftsl != VOID) {
#define BACK_HACK(count, excess) \
    (offset + (count) * sizeof(struct e4_hack_type))
#define LAND_HACK(count) \
    ((count) * sizeof(struct e4_hack_type))

					struct e4_base_type *base_data;
					const struct e4_line_type *line_data;
					void *base, *data;

					data = aile->m.data;

					base_data = hack_base(hack_slip);

					base = base_data;
					if (aile->m.mode
					    (data, &base,
					     BACK_HACK(fare, 0))) {
					    break;
					}

					base_data = base;

					hack_slip = (struct e4_hack_type *)
					    ((char *) base + offset);

					atom_data->data.last.base = hack_slip;

					memcpy(hack_slip, hack_text,
					       LAND_HACK(fare));

					line_data = ftsl_data->line_data;

					last_data = &line_data->last;

					base_data->last_data =
					    &line_data->last;
					base_data->text =
					    (void *) line_data->text;


					if (last_data->bits & TEXT_LINK) {
					    _x1f4_e4_link_laSt(atom_data);
					} else {
					    _x1f4_e4_link_last(atom_data);
					}

					aile->m.free(aile->m.data, atom_text);
					aile->m.free
					    (aile->m.data, fine_data);

					/*
					 * memory comes unused.  the block
					 * keeping the synthetic variable, of
					 * __news_alloc_size__ bytes.
					 */

					*progress |= STAGE_1;

#undef LAND_HACK
#undef BACK_HACK
				    }
				}
			    }
			}
		    }
		}
	    }

	    i--;
	    atom_data++;
	}
    }

    return 0;
}
