/*
 * lxcall-a.b.c
 * Copyright (C) 2011-2014, 2016, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <fd.h>
#include <it.h>
#include <lxcall-defs.h>
#include <lxcall-inter.h>
#include <lxcast.h>
#include <track.h>
#include <trans.h>

static int pick_call(void *, void **, void **,
		     const struct x1f4_function_type *, unsigned, unsigned,
		     struct x1f4_linetext_type *, unsigned, int *);

static int
pick_call(void *output, void **input, void **track,
	  const struct x1f4_function_type *function_data, unsigned offset,
	  unsigned bits, struct x1f4_linetext_type *linetext_data,
	  unsigned norm, int *lock)
{
    int status;

    do {
	if (linetext_data->function.flags
	    & (X1f4_E4_SIDE_LIST | X1f4_E4_SLIP_LIST)) {
	    for (; norm; norm--) {
		status = _libx1f4i0_lxcall_deck_call
		    (input, function_data, offset, linetext_data, *lock);
		if (status) {
		    break;
		} else {
		    lock++;
		}
	    }
	    if (status) {
		break;
	    }
	}

	status = linetext_data->function.function
	    ((void *) linetext_data->context, output, track);
    } while (0);

    return status;
}


int
_libx1f4i0_lxcall_rail_call(struct x1f4_linetext_type *linetext_data,
			    const struct x1f4_function_type *function_data,
			    void *output, unsigned offset, void **input,
			    unsigned bits, struct x1f4_iturn_type *iturn_data,
			    struct x1f4_composer_type *composer_data,
			    struct x1f4_track_type *track_data,
			    const struct x1f4_eelookup_type *eelookup_data,
			    unsigned norm, int *lock,
			    struct fxdata_type *fxdata_data,
			    struct x1f4_dxcast_type *dxcast_data)
{
    int status;
    unsigned i;
    void *meta, **track;

    track = input;

    meta = *(track - 1);

    track += offset;

    i = norm;
    while (1) {
	status = _libx1f4i0_lxcall_even_mark
	    (&linetext_data->function, function_data, offset, &track, bits,
	     iturn_data, composer_data, track_data, eelookup_data, *lock,
	     fxdata_data, dxcast_data);
	if (status) {
	    break;
	} else {
	    i--;
	    if (i) {
		lock++;
		fxdata_data++;
		dxcast_data++;
	    } else {
		break;
	    }
	}
    }
    if (status) {
    } else {
	track[-1] = meta;

	lock -= norm - 1;

	status = pick_call
	    (output, input, track, function_data, offset, bits, linetext_data,
	     norm, lock);
    }

    return status;
}
