/*
 * lxcall-a.o.c
 * Copyright (C) 2011-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>

int
_libx1f4i0_lxcall_hold_call(void **post_data, void **line_data, unsigned parts,
			    int *post_args, const int *line_args,
			    unsigned line, int lead, int lock)
{
    unsigned rail;

    rail = line - lock;

    line_data += lead;

    memcpy(post_data, line_data, lock * sizeof(void *));

    line_data += lock;
    post_data += lock;

    line_args += lead;

    memcpy(post_args, line_args, lock * sizeof(int));

    line_args += lock;
    post_args += lock;

    post_args++;
    post_data++;

    memcpy(post_args, line_args, rail * sizeof(int));

    memcpy(post_data, line_data, rail * sizeof(void *));

    if (parts & X1f4_E4_POST_TYPE) {
	post_args += rail;

	line_args += rail + lead;

	memcpy(post_args, line_args, lock * sizeof(int));

	line_args += lock;
	post_args += lock;

	*post_args++ = 0;

	memcpy(post_args, line_args, rail * sizeof(int));
    }

    return 0;
}
