/*
 * lxcall-i.9.c
 * Copyright (C) 2011-2014, 2016, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>

int
_libx1f4i0_lxcall_deck_call(void **input,
			    const struct x1f4_function_type *function_data,
			    unsigned offset,
			    struct x1f4_linetext_type *linetext_data, int lock)
{
    int *args;
    unsigned class, count, flags;
    void **used;

    count = function_data->count - offset;

    flags = linetext_data->function.flags;

    if (flags & (X1f4_E4_LINK_PASS | X1f4_E4_POST_TYPE)) {
	if (function_data->flags & X1f4_E4_POST_TYPE) {
	    flags |= X1f4_E4_POST_TYPE;
	}
    }

    args = (int *) function_data->args;

    class = linetext_data->function.count;
    if (lock < class) {
	int *line, slip;
	const int *plot;

	line = args;
	plot = linetext_data->function.args;

	line += lock;
	plot += lock;

	slip = *plot;
	*line = slip == X1f4_E4_SLIP ? function_data->args[lock] : slip;

	if (flags & X1f4_E4_POST_TYPE) {
	    if (linetext_data->function.flags & X1f4_E4_POST_TYPE) {
		line[count] = plot[class];
	    } else {
		line[count] = 0;
	    }
	}
    }

    linetext_data->function.args = args;
    linetext_data->function.count = count;
    linetext_data->function.flags =
	flags & ~(X1f4_E4_SIDE_LIST | X1f4_E4_SLIP_LIST);

    used = input[-1];

    used[X1f4_E4_RENDITION] = &linetext_data->function;

    return 0;
}
