/*
 * lxdash-a.j.c
 * Copyright (C) 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxdash-types.h>
#include <lxrail.h>
#include <progress.h>

static const struct x1f4_progress_type progress_0b = {
/* *INDENT-OFF* */
    {	"isk_less(;*, ;0, ;0)",		2,	0,	1,	20	},
    {	"i_last(;*, ;0)",		1,	0,	1,	14	},
	X1f4_E4_MODE,	0,		0,
	X1f4_PROGRESS_BACKWARD,		1
/* *INDENT-ON* */
}, progress_0f = {
/* *INDENT-OFF* */
    {	"isk_greater(;*, ;0, ;0)",	2,	0,	1,	23	},
    {	"i_first(;*, ;0)",		1,	0,	1,	15	},
	X1f4_E4_MODE,	0,		0,	0,	1
/* *INDENT-ON* */
}, progress_1b = {
/* *INDENT-OFF* */
    {	"is_less(;1, ;*, ;0, ;0)",	2,	1,	1,	23	},
    {	"is_last(;1, ;*, ;0)",		1,	1,	1,	19	},
	X1f4_E4_MODE,	X1f4_E4_SLIP,	0,
	X1f4_PROGRESS_BACKWARD,		2
/* *INDENT-ON* */
}, progress_1f = {
/* *INDENT-OFF* */
    {	"is_greater(;1, ;*, ;0, ;0)",	2,	1,	1,	26	},
    {	"is_first(;1, ;*, ;0)",		1,	1,	1,	20	},
	X1f4_E4_MODE,	X1f4_E4_SLIP,	0,	0,	2
/* *INDENT-ON* */
};

int
x1f4_pass_lxdash(void *lxdash, struct x1f4_progress_type **progress,
		 char **copy)
{
    return _libx1f4i0_lxrail_pass_type
	(__types_rail(lxdash), progress, copy, &progress_0f, &progress_0b,
	 &progress_1f, &progress_1b, "is_g_", "is_l_", 5, "(;1, ;*, ;0, ;0)",
	 16);
}
