/*
 * lxdash-b.j.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxdash-drive.h>
#include <lxdash-types.h>

#define l_BILL(e, output) \
    {									      \
	X1f4_E4_C_BILL *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define dxdash(line) \
    ((struct dxdash_type *) (line))

int
_libx1f4i0_lxdash_j_class_b(void *context, void *output, void **input)
{
    int delete;
    struct effect_type effect;
    void *data;

    effect.mode = I_MODE(input[2]);

    delete = x1f4_find_lxfset(dxdash(I_LINE(input[1]))->dash, &effect, &data);
    if (delete) {
	struct effect_type *effect_data;
	unsigned type;

	effect_data = data;

	type = effect_data->type;
	if (type != X1f4_E4_BILL) {
	    l_MODE(0, output);
	} else {
	    l_MODE(1, output);

	    l_BILL(I_BILL(&effect_data->fxdata), input[0]);
	}
    } else {
	l_MODE(0, output);
    }

    return 0;
}
