/*
 * lxdash-p.t.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxcall.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>
#include <trans.h>

#define dxdash(line) \
    ((struct dxdash_type *) (line))
#define lxdash(line) \
    ((struct lxdash_type *) (line))

extern const char *const x1f4_c1_empty_string;

int
_libx1f4i0_lxdash_t_pending(void *context, void *output, void **input)
{
    int status;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    void *data;

    lxdash_data = context;


    effect.mode = I_MODE(input[1]);

    status = x1f4_find_lxfset
	(dxdash(I_LINE(input[0]))->dash, &effect, &data);
    if (status) {
	const char *type;
	struct effect_type *effect_data;
	unsigned link;

	effect_data = data;

	status = 0;

	link = effect_data->link;
	if (link && ~link) {
	    type = ((struct lxtext_type *) lxdash_data->link_f.text
		    + link)->lxtype.name;
	} else {
	    type = x1f4_c1_empty_string;

	    if (lxdash_data->link_v.link) {
		struct trans_type trans;

		trans.data = lxdash_data->link_v.data;
		trans.free = lxdash_data->link_v.free;
		trans.link = lxdash_data->link_v.link;
		trans.mode = lxdash_data->link_v.mode;

		link = effect_data->type;

		status = _libx1f4i0_lxcall_line_type
		    (&type, link, lxdash_data->trap_e.eelookup_data,
		     &trans);
		if (status) {
		    status = _libx1f4i0_lxdash_stat_link(lxdash_data);
		}
	    }
	}

	if (status) {
	} else {
	    l_TEXT((char *) type, output);
	}
    } else {
	status = _libx1f4i0_lxdash_stat_miss(lxdash_data, effect.mode);
    }

    return status;
}
