/*
 * lxdash-s.b.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_fset.h>
#include <e4.h>
#include <lxcall.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_b_sequent(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    dxdash_data = I_LINE(input[0]);

    effect.mode = I_MODE(input[1]);

    status = x1f4_find_lxfset(dxdash_data->dash, &effect, &data);
    if (status) {
	int (*free) (void *, void *, struct excase_type **,
		     const struct excase_type *);
	struct effect_type *effect_data;
	struct lxdash_type *lxdash_data;
	struct lxtext_type *lxtext_link, *lxtext_slip;
	unsigned link;
	void *slip = NULL;

	effect_data = data;

	lxtext_data = context;

	dxdash_data = I_LINE(input[0]);

	lxdash_data = lxtext_data->text;

	lxtext_link = lxdash_data->link_f.text;

	lxtext_slip = lxtext_link;

	link = effect_data->link;

	if (~link) {
	    lxtext_slip += link;

	    free = lxtext_slip->lxtype.free;
	    if (free) {
		slip = I_USER(&effect_data->fxdata);
	    }
	} else {
	    free = NULL;
	}

	if (0) {
	} else {
	    status = lxtext_data->lxtype.node
		(lxtext_data->lxtype.context,
		 (void **) &effect_data->fxdata, I_USER(input[2]),
		 lock_excase(dxdash_data));
	    if (status) {
	    } else {
		unsigned link, type;

		type = lxtext_data->lxtype.code;

		effect_data->type = type;

		link = lxtext_data - lxtext_link;

		effect_data->link = link;

		if (free) {
		    int excess;

		    excess = free
			(lxtext_slip->lxtype.context,
			 (void *) slip, NULL, lock_excase(dxdash_data));
		    if (excess) {
			status = _libx1f4i0_lxcall_land_slip(excess, status);
		    }
		}
	    }
	}
    } else {
	status = _libx1f4i0_lxdash_stat_miss(lxtext_data->text, effect.mode);
    }

    return status;
}
