/*
 * lxdash-v.0-s.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcall.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_0_point_v(void *context, void *output, void **input,
			    int (*seek)(void *, void *, void **))
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    dxdash_data = I_LINE(input[1]);

    lxdash_data = lxtext_data->text;

    effect.mode = I_MODE(input[2]);

    status = seek(dxdash_data->dash, &effect, &data);
    if (status) {
	struct effect_type *effect_data;
	unsigned type;

	effect_data = data;

	type = effect_data->type;
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxdash_stat_type
		(lxtext_data->text, effect_data->mode, type,
		 lxtext_data->lxtype.code);
	} else {
	    l_MODE(effect_data->mode, input[3]);
	    if (0) {
	    } else {
		status = _libx1f4i0_lxcall_land_node
		    (&lxdash_data->link_v, &lxdash_data->link_e,
		     &lxtext_data->lxtype, I_USER(&effect_data->fxdata),
		     input[0]);
		if (status) {
		} else {
		    l_MODE(1, output);
		}
	    }
	}
    } else {
	if (0) {
	} else {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	}
    }

    return status;
}
