/*
 * lxdata-d.r.c
 * Copyright (C) 2008-2010, 2013, 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxdata-types.h>

#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_DATA(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdata_r_derived(void *context, void *output, void **input)
{
    char *lead, *slip;
    struct dxdata_type *dxdata_data;
    unsigned size;

    dxdata_data = I_DATA(input[0]);

    size = dxdata_data->length;

    lead = dxdata_data->string;
    slip = lead + size;

    size >>= 1;
    for (; size; size--) {
	int class;

	class = *lead;
	*lead++ = *--slip;
	*slip = class;
    }

    l_DATA(dxdata_data, output);

    return 0;
}
