/*
 * lxdata-l.d.c
 * Copyright (C) 2008-2010, 2013, 2016, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdata-config.h>

#include <string.h>

#include <e4.h>
#include <lxdata-drive.h>
#include <lxdata-inter.h>
#include <lxdata-size.h>
#include <lxdata-types.h>

extern const char *const x1f4_c1_empty_string;

int
_libx1f4i0_lxdata_d_logique(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_MODE mode;
	struct dxdata_type *dxdata_data;
	unsigned size;

	dxdata_data = I_DATA(input[0]);

	mode = I_MODE(input[1]);

	size = dxdata_data->length;

	if (mode < 0) {
	    if ((X1f4_E4_C_MODE) size < -mode) {
		status = _libx1f4i0_lxdata_stat_deck(context, size, -mode);
		if (1) {
		    break;
		}
	    } else {
		mode = size + mode;
	    }
	} else {
	    if (mode < size) {
	    } else {
		status = _libx1f4i0_lxdata_stat_deck(context, size, mode);
		if (1) {
		    break;
		}
	    }
	}

	--size;

	if (!size) {
	    struct lxdata_type *lxdata_data;

	    lxdata_data = context;

	    status = lxdata_data->link_m.free
		(lxdata_data->link_m.data, dxdata_data->string);
	    if (status) {
		status = _libx1f4i0_lxdata_stat_free(lxdata_data, 0);
		if (1) {
		    break;
		}
	    } else {
		dxdata_data->length = 0;
		dxdata_data->string = (char *) x1f4_c1_empty_string;
	    }
	} else {
	    void *text;

	    text = dxdata_data->string;

	    memmove((char *) text + mode, (char *) text + mode + 1,
		     size + 1 - mode);

	    dxdata_data->length = size;

	    if (case_size(size)) {
		status = 0;
	    } else {
		struct lxdata_type *lxdata_data;

		lxdata_data = context;

		status = lxdata_data->link_m.mode
		    (lxdata_data->link_m.data, &text, size + 1);
		if (status) {
		    status = _libx1f4i0_lxdata_stat_mode(lxdata_data);
		    if (1) {
			break;
		    }
		} else {
		    dxdata_data->string = text;
		}
	    }
	}

	l_DATA(dxdata_data, output);
    } while (0);

    return status;
}
