/*
 * lxdata-s.p.c
 * Copyright (C) 2008-2014, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdata-drive.h>
#include <lxdata-types.h>

int
_libx1f4i0_lxdata_p_sequent(void *context, void *output, void **input)
{
    do {
	X1f4_E4_C_MODE mode;
	struct dxdata_type *dxdata_data;
	unsigned size;

	dxdata_data = I_DATA(input[1]);

	mode = I_MODE(input[2]) - 1;

	size = dxdata_data->length;

	if (mode < 0) {
	    if ((X1f4_E4_C_MODE) size < -mode) {
		l_MODE(0, output);

		if (1) {
		    break;
		}
	    } else {
		l_MODE(mode, input[2]);
	    }

	    mode = size + mode;
	} else {
	    if (mode < size) {
		l_MODE(mode, input[2]);
	    } else {
		l_MODE(0, output);

		if (1) {
		    break;
		}
	    }
	}

	l_MODE(1, output);

	l_MODE(((unsigned char *) dxdata_data->string)[mode], input[0]);
    } while (0);

    return 0;
}
