/*
 * lxdecq-u.g.f.c
 * Copyright (C) 2008-2010, 2013, 2014, 2016-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <f_list.h>
#include <lxcall.h>
#include <lxdecq-drive.h>
#include <lxdecq-inter.h>
#include <lxdecq-types.h>

int
_libx1f4i0_lxdecq_gfclass_u(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    dxlist_data = I_LIST(input[1]);

    status = _libx1f4i0_lead_dllist(dxlist_data->list, &data);
    if (status) {
	status = _libx1f4i0_lxdecq_stat_list(lxtext_data->text, 0, status);
    } else {
	unsigned type;

	type = effect_type(data);
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxdecq_stat_type
		(lxtext_data->text, 0, type, lxtext_data->lxtype.code);
	} else {
	    X1f4_E4_C_USER fast;

	    fast = E_USER(data);
	    if (lxtext_data->lxtype.copy && lxtext_data->lxtype.push) {
		status = _libx1f4i0_lxcall_side_node
		    (&lxtext_data->lxtype, fast, input[0]);
		if (status) {
		} else {
		    l_USER(I_USER(input[0]), output);
		}
	    } else {
		l_USER(fast, input[0]);
		l_USER(fast, output);
	    }
	}
    }

    return status;
}

