/*
 * lxfile-l.y.c
 * Copyright (C) 2016, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxcall.h>
#include <lxfile-drive.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>

int
_libx1f4i0_lxfile_y_logique(void *context, void *output, void **input)
{
    int status;
    void *data;

    status = x1f4_line_lxfile(context, &data);
    if (status) {
    } else {
	struct lxfile_type *lxfile_data;

	lxfile_data = context;

	status = _libx1f4i0_lxcall_near_node
	    (&lxfile_data->link_v, &lxfile_data->link_e,
	     lxfile_data->link_t.datatype, data);
	if (status) {
	    _libx1f4i0_lxfile_slip_file(context, &data);
	} else {
	    l_FILE(data, output);
	}
    }

    return status;
}
