/*
 * lxline-d.q.c
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxdata.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_q_derived(void *context, void *output, void **input)
{
    char *text;
    int status;
    void *data;

    text = ((struct x1f4_dxdata_type *) I_DATA(input[1]))->string;

    status = _libx1f4i0_find_sfnote(Q_LINE(input[0])->line, text, &data);
    if (status) {
	status = _libx1f4i0_lxrail_post_data
	    (context, output, effect_link(data), effect_type(data),
	     effect_data(data));
    } else {
	status = _libx1f4i0_lxline_stat_miss(context, text);
    }

    return status;
}
