/*
 * lxline-f.n.c
 * Copyright (C) 2008-2011, 2013, 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define l_LINE(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxline_n_forward(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;

    dxline_data = I_LINE(input[0]);

    lxline_data = context;

    if (lock_exline(dxline_data)->call == 1) {
	if (dxline_data->size) {
	    status = _libx1f4i0_lxline_null_line(context, NULL, dxline_data);
	} else {
	    status = 0;
	}
    } else {
	status = _libx1f4i0_lxline_line_line(lxline_data, input[0]);
	if (status) {
	} else {
	    status = _libx1f4i0_lxcall_near_node
		(&lxline_data->link_v, &lxline_data->link_e,
		 lxline_data->link_t.datatype, dxline_data);
	}
    }

    return status;
}
