/*
 * lxline-n.c.c
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define dxline(dxline) \
    ((struct dxline_type *) (dxline))

int
_libx1f4i0_lxline_c_nearest(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data, *dxline_text;
    void *subtext;

    dxline_data = I_LINE(input[0]);
    dxline_text = I_LINE(input[1]);

    subtext = context;

    if (dxline_data == dxline_text) {
	status = 0;
    } else {
	void *dxtext;

	status = _libx1f4i0_lxline_line_line(subtext, &dxtext);
	if (status) {
	} else {
	    void *becca[3];

	    becca[0] = context;
	    becca[2] = dxline_data;

	    status = _libx1f4i0_line_sfnote
		(dxline(dxtext)->line, dxline_text->line,
		 _libx1f4i0_lxline_size_link, _libx1f4i0_lxline_link_link,
		 _libx1f4i0_lxline_free_link, becca);
	    if (status) {
		status = _libx1f4i0_lxline_stat_line(context, 0, status);
	    } else {
                dxline(dxtext)->size = dxline_text->size;

		status = _libx1f4i0_lxline_null_line
		    (context, NULL, dxline_data);
		if (status) {
		} else {
		    status = _libx1f4i0_lxline_swap_line(dxtext, dxline_data);
		}
	    }

	    if (1) {
		int excess;

		excess = _libx1f4i0_lxline_flat_line(subtext, &dxtext);
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    }
	}
    }

    return status;
}
