/*
 * lxline-s.b.c
 * Copyright (C) 2008-2015, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_b_sequent(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct lxtext_type *lxtext_data;
    void *slip, *data;

    lxtext_data = context;

    dxline_data = I_LINE(input[0]);

    status = _libx1f4i0_find_sfnote
	(dxline_data->line, I_TEXT(input[1]), &data);
    if (status) {
	int (*free) (void *, void *, struct excase_type **,
		     const struct excase_type *);
	struct lxline_type *lxline_data;
	struct lxtext_type *lxtext_link, *lxtext_slip;
	unsigned link;

	slip = data;

	lxtext_data = context;

	dxline_data = I_LINE(input[0]);

	lxline_data = lxtext_data->text;

	lxtext_link = lxline_data->link_f.text;

	link = effect_link(slip);

	lxtext_slip = lxtext_link;

	if (~link) {
	    lxtext_slip += link;

	    free = lxtext_slip->lxtype.free;
	    if (free) {
		slip = E_USER(slip);
	    }
	} else {
	    free = NULL;
	}

	if (0) {
	} else {
	    status = lxtext_data->lxtype.node
		(lxtext_data->lxtype.context,
		 (void **) (effect_data(data)), I_USER(input[2]),
		 lock_excase(dxline_data));
	    if (status) {
	    } else {
		unsigned link, type;

		type = lxtext_data->lxtype.code;

		type_effect(data, type);

		link = lxtext_data - lxtext_link;

		link_effect(data, link);

		if (free) {
		    int excess;

		    excess = free
			(lxtext_slip->lxtype.context,
			 (void *) slip, NULL, lock_excase(dxline_data));
		    if (excess) {
			status = _libx1f4i0_lxcall_land_slip(excess, status);
		    }
		}
	    }
	}
    } else {
	status = _libx1f4i0_lxline_stat_miss
	    (lxtext_data->text, I_TEXT(input[1]));
    }

    return status;
}
