/*
 * lxline-t.f.c
 * Copyright (C) 2008-2015, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <e4.h>
#include <fd.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_f_class_t(void *context, void *output, void **input)
{
    X1f4_E4_C_TEXT fail;
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    struct lxtext_type *lxtext_data, *lxtext_link;
    unsigned link;
    void *data, *side;

    dxline_data = I_LINE(input[0]);

    lxtext_data = context;

    lxline_data = lxtext_data->text;

    fail = I_TEXT(input[1]);

    do {
	lxtext_link = lxline_data->link_f.text;

	status = lxtext_data->lxtype.copy
	    (lxtext_data->lxtype.context, NULL, &side,
	     I_USER(input[2]), lock_excase(dxline_data));
	if (status) {
	    if (1) {
		break;
	    }
	}

	status = _libx1f4i0_post_sfnote
	    (dxline_data->line, fail, effect_size,
	     &data);
	if (status) {
	    if (status ^ X1f4_SFNOTE_EVER_MATCH) {
		status =
		    _libx1f4i0_lxline_stat_line(lxline_data, 0, status);

		lxtext_data->lxtype.free
		    (lxtext_data->lxtype.context, side,
		     NULL, lock_excase(dxline_data));

		break;
	    } else {
		void *slip;

		status = 0;

		slip = data;

		link = effect_link(slip);

		if (~link) {
		    int (*free)(void *, void *, struct excase_type **,
				const struct excase_type *);
		    struct lxtext_type *lxtext_slip;

		    lxtext_slip = lxtext_link + link;

		    free = lxtext_slip->lxtype.free;
		    if (free) {
			status = free
			    (lxtext_slip->lxtype.context,
			     E_USER(slip), NULL,
			     lock_excase(dxline_data));
		    }
		}
	    }
	} else {
	    dxline_data->size++;
	}

	{
#define type				X1f4_E4_TEXT

	    unsigned link;

	    type_effect(data, type);

	    link = lxtext_data - lxtext_link;

	    link_effect(data, link);

	    l_TEXT(side, effect_data(data));

#undef type
	}

	if (status) {
	} else {
	    status = x1f4_auto_text
		(&lxline_data->link_v, &lxline_data->link_e, side,
		 strlen(side), output);
	}
    } while (0);

    return status;
}
