/*
 * lxlist-r.q-c.c
 * Copyright (C) 2008-2011, 2013, 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_list.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define l_REAL(e, output) \
    {									      \
	X1f4_E4_C_REAL *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define lxtext(lxtext)			((struct lxtext_type *) (lxtext))

int
_libx1f4i0_lxlist_y_class_r(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;

    dxlist_data = I_LIST(input[0]);
    if (0) {
    } else {
	X1f4_E4_C_MODE mode;
	unsigned size;

	mode = I_MODE(input[1]);

	size = dxlist_data->size;
	if (mode < -(X1f4_E4_C_MODE) (int) size
	    || !(mode < (X1f4_E4_C_MODE) (int) size)) {
	    status = _libx1f4i0_lxlist_stat_deck
		(lxtext(context)->text, size, mode);
	} else {
	    void *data;

	    if (mode < 0) {
		mode += size;
	    }

	    status = _libx1f4i0_peek_l4list(dxlist_data->list, mode, &data);
	    if (status) {
		status = _libx1f4i0_lxlist_stat_list
		    (lxtext(context)->text, 0, status);
	    } else {
		unsigned type;

		type = effect_type(data);
		switch (type) {
		case X1f4_E4_BILL:
		    l_REAL(E_BILL(data), output);
		    break;
		case X1f4_E4_MODE:
		    l_REAL(E_MODE(data), output);
		    break;
		case X1f4_E4_REAL:
		    l_REAL(E_REAL(data), output);
		    break;
		default:
		    status = _libx1f4i0_lxlist_stat_type
			(lxtext(context)->text, mode, type, X1f4_E4_REAL);
		}
	    }
	}
    }

    return status;
}
