/*
 * lxlist-v.q.b.c
 * Copyright (C) 2008-2011, 2013-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_list.h>
#include <lxcall.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

int
_libx1f4i0_lxlist_qbclass_v(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;
    struct lxlist_type *lxlist_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    lxlist_data = lxtext_data->text;

    dxlist_data = I_LIST(input[0]);

    status = _libx1f4i0_ever_l4list(dxlist_data->list, &data);
    if (status) {
	status = _libx1f4i0_lxlist_stat_list(lxlist_data, 0, status);
    } else {
	unsigned type;

	type = effect_type(data);
	if (type != lxtext_data->lxtype.code) {
	    struct lxtext_type *lxtext_data;

	    lxtext_data = context;

	    status = _libx1f4i0_lxlist_stat_type
		(lxlist_data, dxlist_data->size - 1, type,
		 lxtext_data->lxtype.code);
	} else {
	    status = x1f4_auto_node
		(&lxlist_data->link_v, &lxlist_data->link_e,
		 &lxtext_data->lxtype, effect_data(data), output);
	}
    }

    return status;
}
