/*
 * lxlist-v.x.f.c
 * Copyright (C) 2008-2011, 2013-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxlist-config.h>

#include <e4.h>
#include <exerrors.h>
#include <l_list.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#undef __CLIP_EXTRACT__
#define __CLIP_EXTRACT__		0

#if __CLIP_EXTRACT__
# define clip(none) \
    ((struct clip_type *) (none))
#endif				/* __CLIP_EXTRACT__ */

#if __CLIP_EXTRACT__
typedef struct clip_type {
    unsigned type;
    void *output;
} clip_type;
#endif				/* __CLIP_EXTRACT__ */

#if __CLIP_EXTRACT__
static int clip_miss(void *, void *);
#endif				/* __CLIP_EXTRACT__ */

#if __CLIP_EXTRACT__
static int
clip_miss(void *clip, void *data)
{
    int status;
    unsigned type;

    type = effect_type(data);
    if (type ^ clip(clip)->type) {
	clip(clip)->type = type;

	something missing here

	status = 1;
    } else {
	status = 0;

	l_USER(E_TEXT(data), clip(clip)->output);
    }

    return status;
}
#endif				/* __CLIP_EXTRACT__ */


int
_libx1f4i0_lxlist_xfclass_v(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;
    struct lxlist_type *lxlist_data;
    struct lxtext_type *lxtext_data;
#if __CLIP_EXTRACT__
    struct clip_type clip;
#else
    void *data, *list;
#endif				/* __CLIP_EXTRACT__ */

    lxtext_data = context;

    lxlist_data = lxtext_data->text;

    dxlist_data = I_LIST(input[0]);

#if __CLIP_EXTRACT__
    clip.output = output;
#endif				/* __CLIP_EXTRACT__ */

#if __CLIP_EXTRACT__
#else
    list = dxlist_data->list;
#endif				/* __CLIP_EXTRACT__ */

#if __CLIP_EXTRACT__
    status = _libx1f4i0______l4list
	(dxlist_data->list, &clip, clip_miss);
    if (status) {
	status = _libx1f4i0_lxlist_stat_call
	    (lxlist_data, 0, clip.type,
	     lxtext_data->lxtype.code, status);
    } else {
	dxlist_data->size--;
    }
#else
    status = _libx1f4i0_lead_l4list(list, &data);
    if (status) {
	status = _libx1f4i0_lxlist_stat_list(lxlist_data, 0, status);
    } else {
	unsigned type;

	type = effect_type(data);
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxlist_stat_type
		(lxlist_data, 0, type, lxtext_data->lxtype.code);
	} else {
	    void *fast;

	    fast = E_USER(data);

	    l_USER(fast, output);

	    status = lxtext_data->lxtype.push
		(lxtext_data->lxtype.context, output, fast,
		 lock_excase(dxlist_data));
	    if (status) {
	    } else {
		link_effect(data, ~0);

		status = _libx1f4i0_mind_l4list(list);
		if (status) {
		    status = _libx1f4i0_lxlist_stat_list
			(lxlist_data, 0, status);
		} else {
		    dxlist_data->size--;
		}
	    }
	}
    }
#endif				/* __CLIP_EXTRACT__ */

    return status;
}
