/*
 * lxlock.h
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxlock_H__
#define __LIBx1f4_lxlock_H__

#include <frame.h>
#include <nl.h>
#include <track.h>
#include <trans.h>

#define link_e				ever_a.diff_e
#define link_m				ever_a.diff_m
#define link_v				ever_a.diff_v
#define link_w				ever_a.diff_w

/*
 * NOTES
 *
 *.some error recorder in addition to the error dumper is in good order.  such
 * recorder would record the error type (this library identification -
 * application side, since such identification is created by the application)
 * and the error details (library error type and details)
 */
typedef struct lxlock_type {
    struct x1f4_track_type diff_e;
    struct x1f4_trans_type diff_m;
    struct x1f4_frame_type diff_v;
    struct x1f4_trans_type diff_w;
} lxlock_type;

extern int _libx1f4i0_lxlock_fuse_link(void *, int);
extern int _libx1f4i0_lxlock_lock_link(void *, int);
extern int _libx1f4i0_lxlock_stat_free(void *, int);
extern int _libx1f4i0_lxlock_stat_getf(void *);
extern int _libx1f4i0_lxlock_stat_land(void *, unsigned, long);
extern int _libx1f4i0_lxlock_stat_link(void *);
extern int _libx1f4i0_lxlock_stat_mode(void *);
extern int _libx1f4i0_lxlock_stat_roll(void *, const char *, unsigned);
extern int _libx1f4i0_lxlock_stat_setf(void *);
extern int _libx1f4i0_lxlock_stat_zero(void *, const char *, unsigned);

#endif				/* __LIBx1f4_lxlock_H__ */
