/*
 * lxnear-f.e.c
 * Copyright (C) 2008-2010, 2013, 2014, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <e4.h>
#include <lxdata.h>
#include <lxnear-defs.h>
#include <lxnear-drive.h>
#include <lxnear-types.h>
#include <sstring.v-i.h>

extern const unsigned _libx1f4i0_escapes[];

int
_libx1f4i0_lxnear_e_forward(void *context, void *output, void **input)
{
    struct lxtext_type *lxtext_data;
    struct x1f4_dxdata_type *dxdata_data;

    lxtext_data = context;

    if (lxtext_data->bits & TYPED_TEXT) {
	X1f4_E4_C_USER user;

	user = I_USER(input[0]);
	lxtext_data->lead[1] = user;
	l_USER(user, output);
	input++;
    }

    dxdata_data = I_USER(input[0]);

    return x1f4_vprint_isstring
	(lxtext_data->data, lxtext_data->push, dxdata_data->string,
	 dxdata_data->length, _libx1f4i0_escapes);
}
