/*
 * lxnear-l.f.c
 * Copyright (C) 2008-2010, 2013, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <e4.h>
#include <lintegral.v-f.h>
#include <lxnear-defs.h>
#include <lxnear-drive.h>
#include <lxnear-types.h>

int
_libx1f4i0_lxnear_f_logique(void *context, void *output, void **input)
{
    int status;
    struct lxtext_type *lxtext_data;

    lxtext_data = context;

    if (lxtext_data->bits & TYPED_TEXT) {
	X1f4_E4_C_USER user;

	user = I_USER(input[0]);
	lxtext_data->lead[1] = user;
	l_USER(user, output);
	input++;
    }

    do {
	X1f4_E4_C_MODE f, x;

	f = I_MODE(input[0]);
	if (f < 0) {
	    status = 0;
	    if (1) {
		break;
	    }
	}

	x = I_MODE(input[1]);
	if (x < 2) {
	    status = 0;
	    if (1) {
		break;
	    }
	} else {
	    if (36 < x) {
		status = 0;
		if (1) {
		    break;
		}
	    }
	}

	status = x1f4_vprint_flintegral
	    (lxtext_data->data, lxtext_data->push, 0, f, x, I_MODE(input[2]));
    } while (0);

    return status;
}
