/*
 * lxplus-types.h
 * Copyright (C) 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxplus_H__
#define __LIBx1f4_lxplus_H__

#include <ln.h>
#include <lxnorm.h>
#include <nl.h>
#include <nt.h>

#define excase_type			x1f4_nodelink_type
#define exlist_type			x1f4_nodeline_type

#define cxlist_type			x1f4_leadnode_type

#define here_NULL			((void *) 0)

#define here_offsetof(type, ceil) \
    ((integral_q) (&((type *) here_NULL)->ceil))

#define lock_excase(dxlist_text) \
    ((struct excase_type *) &lock_cxlist((dxlist_text))->link)

#define lock_exlist(dxlist_text) \
    ((struct exlist_type *) &lock_cxlist((dxlist_text))->line)

#define lock_cxlist(dxlist_text) \
    ((struct cxlist_type *)						      \
     ((char *) (dxlist_text) - sizeof(struct cxlist_type)))

#define near_dxlist(excase_text) \
    ((struct dxlist_type *)						      \
     ((char *) near_cxlist((excase_text)) + sizeof(struct cxlist_type)))

#define near_exlist(excase_text) \
    ((struct exlist_type *) &near_cxlist((excase_text))->line)

#define near_cxlist(excase_text) \
    ((struct cxlist_type *)						      \
     ((char *) (excase_text) - here_offsetof(struct cxlist_type, link)))

#define pick_dxlist(fxlist_text) \
    ((struct dxlist_type *)						      \
     ((char *) (fxlist_text) + sizeof(struct cxlist_type)))

#define post_dxlist(dxlist_text) \
    ((struct dxlist_type *) (dxlist_text) + 1)

typedef struct lxplus_type {
    struct lxnorm_type ever_n;
    struct {
	int (*call)(void *, struct x1f4_nodelink_type *),
	    (*fine)(void *, struct x1f4_nodelink_type **,
		    struct x1f4_nodelink_type *),
	    (*miss)(void *, struct x1f4_nodelink_type **,
		    struct x1f4_nodelink_type *);
	void *text;
    } link_r;
    struct {
	struct x1f4_nodetype_type nodetype[1];
    } link_s;
} lxplus_type;

#endif				/* __LIBx1f4_lxplus_H__ */
