/*
 * lxpoll-a.l.c
 * Copyright (C) 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_e101.h>
#include <lxcall.h>
#include <lxlead.h>
#include <lxpoll-defs.h>
#include <lxpoll-inter.h>
#include <lxpoll-types.h>
#include <nl.h>

#define dxpoll(poll) \
    ((struct dxpoll_type *) (poll))

int
_libx1f4i0_lxpoll_null_poll(void *lxpoll, struct x1f4_nodelink_type **nodelink,
			    void *dxpoll)
{
    int excess, status = 0;
    struct x1f4_nodelink_type *nodelink_data;
    void **track;

    if (nodelink) {
	nodelink_data = *nodelink;
    } else {
	nodelink_data = NULL;
    }

    track = dxpoll(dxpoll)->notion;
    if (track) {
	dxpoll(dxpoll)->notion = NULL;

	if ((integral_q) track[BITS_LEAD] & HALF_LINE) {
	    status = _libx1f4i0_lxpoll_flat_line(NULL, track);
	}
    }

    excess = Mylene101_high_device(dxpoll(dxpoll)->device, &nodelink_data);
    if (excess) {
	excess = _libx1f4i0_lxpoll_stat_user(lxpoll, excess);
	status = _libx1f4i0_lxcall_land_slip(excess, status);
    }

    if (nodelink) {
	*nodelink = nodelink_data;
    } else {
	if (nodelink_data) {
	    excess = x1f4_fail_lxlead(nodelink_data);
	    if (excess) {
		status = _libx1f4i0_lxcall_land_slip(excess, status);
	    }
	}
    }

    return status;
}
