/*
 * lxpoll-e.k.c
 * Copyright (C) 2010, 2011, 2013-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxpoll-defs.h>
#include <lxpoll-inter.h>
#include <lxpoll-types.h>
#include <lxwide.h>

static int init_poll(void **, unsigned, struct x1f4_lxwide_type *, unsigned,
		     const void *, unsigned, struct screen_type *);

static int
init_poll(void **lxpoll, unsigned bits, struct x1f4_lxwide_type *lxwide_data,
	  unsigned tile, const void *data, unsigned flags,
	  struct screen_type *screen_data)
{
    if (1) {
	screen_data->lock_t.data = lxwide_data->datatype_set.nodetype_data;
	screen_data->lock_t.miss = lxwide_data->datatype_set.miss;
    }

    if (bits & X1f4_LXWIDE_CODELINK) {
	if (flags & CODELINK_LINK) {
	} else {
	    flags |= CODELINK_LINK;
	    screen_data->lock_w = lxwide_data->codelink_set;
	}
    }

    if (bits & X1f4_LXWIDE_COMPOSER) {
	if (flags & COMPOSER_LINK) {
	} else {
	    flags |= COMPOSER_LINK;
	    screen_data->link_q = lxwide_data->composer_set;
	}
    }

    if (bits & X1f4_LXWIDE_MISSBAIL) {
	if (flags & MISSBAIL_LINK) {
	} else {
	    flags |= MISSBAIL_LINK;
	    screen_data->lock_r.call = lxwide_data->missbail_set.call;
	    screen_data->lock_r.fine = lxwide_data->missbail_set.fine;
	    screen_data->lock_r.miss = lxwide_data->missbail_set.miss;
	    screen_data->lock_r.text = lxwide_data->missbail_set.text;
	}
    }

    if (bits & X1f4_LXWIDE_RESOURCE) {
	if (flags & RESOURCE_LINK) {
	} else {
	    flags |= RESOURCE_LINK;
	    screen_data->lock_m = lxwide_data->resource_set;
	}
    }

    if (1) {
	if (0) {
	} else {
	    screen_data->lock_v = lxwide_data->autolink_set;
	}
    }

    if (1) {
	if (flags & EELOOKUP_LINK) {
	} else {
	    flags |= EELOOKUP_LINK;
	    screen_data->lock_g.eelookup_data =
		lxwide_data->eelookup_set.eelookup_data;
	}
    }

    if (bits & X1f4_LXWIDE_TEXTFLAT) {
	if (flags & TEXTFLAT_LINK) {
	} else {
	    flags |= TEXTFLAT_LINK;
	    screen_data->lock_e = lxwide_data->textflat_set;
	}
    }

    return _libx1f4i0_lxpoll_init_poll(lxpoll, flags, screen_data);
}


int
x1f4_tile_lxpoll(void **lxpoll, unsigned bits,
		 struct x1f4_lxwide_type *lxwide_data, unsigned tile,
		 const void *data)
{
    int status;

    do {
	int type;
	struct screen_type screen;
	unsigned flags;

	if (data) {
	    screen = *(const struct screen_type *) data;
	}

	flags = tile;

	if (1) {
	    lxwide_data->widetype_set.type++;
	    screen.link_l.type = lxwide_data->widetype_set.type;
	}

	if (x1f4_mind_lxwide(&type, lxwide_data, "date", 4)) {
	    screen.link_i.date = type;
	} else {
	    status = 1;
	    if (1) {
		break;
	    }
	}

	if (x1f4_mind_lxwide(&type, lxwide_data, "file", 4)) {
	    screen.link_i.file = type;
	} else {
	    status = 1;
	    if (1) {
		break;
	    }
	}

	status = init_poll
	    (lxpoll, bits, lxwide_data, tile, data, flags, &screen);
    } while (0);

    return status;
}
