/*
 * lxrail-e.p.c
 * Copyright (C) 2014-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxrail-types.h>

int
_libx1f4i0_lxrail_line_cast(struct depart_type *depart_data, unsigned pass,
			    void **line)
{
    struct x1f4_fpdetail_type *fpdetail_data;

    pass++;

    fpdetail_data = *line;

    depart_data->ftsl_alaw = (void *) (fpdetail_data + 8);
    depart_data->ftsl_blaw = depart_data->ftsl_alaw + pass;
    depart_data->ftsl_claw = depart_data->ftsl_blaw + pass;
    depart_data->ftsl_dlaw = depart_data->ftsl_claw + pass;
    depart_data->ftsl_flaw = depart_data->ftsl_dlaw + pass;
    depart_data->ftsl_llaw = depart_data->ftsl_flaw + pass;
    depart_data->ftsl_plaw = depart_data->ftsl_llaw + pass;
    depart_data->ftsl_rlaw = depart_data->ftsl_plaw + pass;

    *line = depart_data->ftsl_rlaw + pass;

    fpdetail_data->bits1 = X1f4_E4_EVER_LIST;
    fpdetail_data->ftsl_data = depart_data->ftsl_alaw;

    depart_data->fpdetail_alaw = fpdetail_data;

    fpdetail_data++;

    fpdetail_data->bits1 = X1f4_E4_EVER_LIST;
    fpdetail_data->ftsl_data = depart_data->ftsl_blaw;

    depart_data->fpdetail_blaw = fpdetail_data;

    fpdetail_data++;

    fpdetail_data->bits1 = X1f4_E4_EVER_LIST;
    fpdetail_data->ftsl_data = depart_data->ftsl_claw;

    depart_data->fpdetail_claw = fpdetail_data;

    fpdetail_data++;

    fpdetail_data->bits1 = X1f4_E4_EVER_LIST;
    fpdetail_data->ftsl_data = depart_data->ftsl_dlaw;

    depart_data->fpdetail_dlaw = fpdetail_data;

    fpdetail_data++;

    fpdetail_data->bits1 = X1f4_E4_EVER_LIST;
    fpdetail_data->ftsl_data = depart_data->ftsl_flaw;

    depart_data->fpdetail_flaw = fpdetail_data;

    fpdetail_data++;

    fpdetail_data->bits1 = X1f4_E4_EVER_LIST;
    fpdetail_data->ftsl_data = depart_data->ftsl_llaw;

    depart_data->fpdetail_llaw = fpdetail_data;

    fpdetail_data++;

    fpdetail_data->bits1 = X1f4_E4_EVER_LIST;
    fpdetail_data->ftsl_data = depart_data->ftsl_plaw;

    depart_data->fpdetail_plaw = fpdetail_data;

    fpdetail_data++;

    fpdetail_data->bits1 = X1f4_E4_EVER_LIST;
    fpdetail_data->ftsl_data = depart_data->ftsl_rlaw;

    depart_data->fpdetail_rlaw = fpdetail_data;

    return 0;
}
