/*
 * lxrail-e.u.c
 * Copyright (C) 2014-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxrail-types.h>

int
_libx1f4i0_lxrail_line_past(struct depart_type *depart_data, unsigned pass,
			    void **line)
{
    struct x1f4_fpdetail_type *fpdetail_data;

    pass++;

    fpdetail_data = *line;

    depart_data->ftaa_qlaw = (void *) (fpdetail_data + 4);
    depart_data->ftaa_xlaw = depart_data->ftaa_qlaw + pass;
    depart_data->ftca_qlaw = (void *) (depart_data->ftaa_xlaw + pass);
    depart_data->ftca_xlaw = depart_data->ftca_qlaw + pass;
    depart_data->ftsl_glaw = (void *) (depart_data->ftca_xlaw + pass);
    depart_data->ftsl_ylaw = depart_data->ftsl_glaw + pass;

    *line = depart_data->ftsl_ylaw + pass;

    fpdetail_data->bits1 = X1f4_E4_TYPE_LIST | X1f4_E4_XSET_LIST;
    fpdetail_data->ftaa_data = depart_data->ftaa_qlaw;
    fpdetail_data->ftca_data = depart_data->ftca_qlaw;

    depart_data->fpdetail_qlaw = fpdetail_data;

    fpdetail_data++;

    fpdetail_data->bits1 = X1f4_E4_TYPE_LIST | X1f4_E4_XSET_LIST;
    fpdetail_data->ftaa_data = depart_data->ftaa_xlaw;
    fpdetail_data->ftca_data = depart_data->ftca_xlaw;

    depart_data->fpdetail_xlaw = fpdetail_data;

    fpdetail_data++;

    fpdetail_data->bits1 = X1f4_E4_LEAD_LIST;
    fpdetail_data->ftsl_data = depart_data->ftsl_glaw;

    depart_data->fpdetail_glaw = fpdetail_data;

    fpdetail_data++;

    fpdetail_data->bits1 = X1f4_E4_LEAD_LIST;
    fpdetail_data->ftsl_data = depart_data->ftsl_ylaw;

    depart_data->fpdetail_ylaw = fpdetail_data;

    return 0;
}
