/*
 * lxroll-inter.h
 * Copyright (C) 2008-2012, 2014, 2016, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxroll_inter_H__
#define __LIBx1f4_lxroll_inter_H__

#include <e4.h>
#include <ix.h>
#include <lxlock.h>
#include <lxroll-types.h>
#include <lxwide.h>

#define _libx1f4i0_lxroll_fini_roll	x1f4_fini_lxroll
#define _libx1f4i0_lxroll_fset_roll	x1f4_fset_lxroll
#define _libx1f4i0_lxroll_init_roll	x1f4_init_lxroll
#define _libx1f4i0_lxroll_tile_roll	x1f4_tile_lxroll
#define _libx1f4i0_lxroll_vset_roll	x1f4_vset_lxroll
#define _libx1f4i0_lxroll_wrap_roll	x1f4_wrap_lxroll

#define __types_lock(lxroll) \
    (&((struct lxroll_type *) (lxroll))->ever_a)

#define _libx1f4i0_lxroll_lock_link(___l, ___1) \
    _libx1f4i0_lxlock_lock_link(__types_lock((___l)), (___1))
#define _libx1f4i0_lxroll_stat_free(___l, ___1) \
    _libx1f4i0_lxlock_stat_free(__types_lock((___l)), (___1))
#define _libx1f4i0_lxroll_stat_getf(___l) \
    _libx1f4i0_lxlock_stat_getf(__types_lock((___l)))
#define _libx1f4i0_lxroll_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_lock((___l)))
#define _libx1f4i0_lxroll_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_lock((___l)))
#define _libx1f4i0_lxroll_stat_setf(___l) \
    _libx1f4i0_lxlock_stat_setf(__types_lock((___l)))

extern int _libx1f4i0_lxroll_a_logique(void *, void *, void **);
extern int _libx1f4i0_lxroll_c_forward(void *, void *, void **);
extern int _libx1f4i0_lxroll_fini_roll(void **);
extern int _libx1f4i0_lxroll_fset_roll
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxroll_init_roll
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxroll_l_forward(void *, void *, void **);
extern int _libx1f4i0_lxroll_land_roll
    (void *, void *, unsigned, void *, int *, void *, int *);
extern int _libx1f4i0_lxroll_p_logique(void *, void *, void **);
extern int _libx1f4i0_lxroll_stat_back(void *);
extern int _libx1f4i0_lxroll_stat_call(void *, const char *);
extern int _libx1f4i0_lxroll_stat_flat(void *);
extern int _libx1f4i0_lxroll_stat_info(void *, const char *, const char *);
extern int _libx1f4i0_lxroll_stat_lock(void *, const char *);
extern int _libx1f4i0_lxroll_stat_part(void *, int);
extern int _libx1f4i0_lxroll_stat_side(void *);
extern int _libx1f4i0_lxroll_tile_roll
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxroll_vset_roll(void *, void **);
extern int _libx1f4i0_lxroll_wrap_roll(void *, struct x1f4_indexset_type *);

#endif				/* __LIBx1f4_lxroll_inter_H__ */
