/*
 * lxroll-l.p.c
 * Copyright (C) 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <unistd.h>

#include <e4.h>
#include <lxroll-inter.h>
#include <lxroll-types.h>

#define I_FILE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))

int
_libx1f4i0_lxroll_p_logique(void *context, void *output, void **input)
{
    int fd = -1, ld = -1, status;

    do {
	int fife[2];
        struct lxroll_type *lxroll_data;
        struct x1f4_dxfile_type *dxfile_data, *dxfile_text;
	unsigned bits;
        void *lxfile;

        lxroll_data = context;

        lxfile = lxroll_data->link_l.file;

        dxfile_data = I_FILE(input[0]);

        dxfile_text = I_FILE(input[1]);

        if (dxfile_data == dxfile_text) {
	    status = _libx1f4i0_lxroll_stat_back(lxroll_data);
            if (1) {
                break;
            }
	}

	/*
	 * pipe(2) before closing any files.
	 */

	status = pipe(fife);
	if (status) {
	    status = _libx1f4i0_lxroll_stat_call(lxroll_data, "pipe");
	    if (1) {
		break;
	    }
	}

        bits = I_MODE(input[2]);

	fd = fife[0];
	ld = fife[1];

	status = _libx1f4i0_lxroll_land_roll
	    (lxroll_data, lxfile, bits, dxfile_data, &fd, dxfile_text, &ld);
    } while (0);

    if (fd ^ -1) {
	close(fd);
    }

    if (ld ^ -1) {
	close(ld);
    }

    return status;
}
