/*
 * lxtime-l.y.c
 * Copyright (C) 2016, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxcall.h>
#include <lxdate-drive.h>
#include <lxdate-inter.h>
#include <lxdate-types.h>

int
_libx1f4i0_lxtime_y_logique(void *context, void *output, void **input)
{
    int status;
    void *data;

    status = x1f4_line_lxtime(context, &data);
    if (status) {
    } else {
	struct lxdate_type *lxdate_data;

	lxdate_data = context;

	status = _libx1f4i0_lxcall_near_node
	    (&lxdate_data->link_v, &lxdate_data->link_e,
	     lxdate_data->link_t.datatype + 1, data);
	if (status) {
	    _libx1f4i0_lxdate_slip_time(context, &data);
	} else {
	    l_TIME(data, output);
	}
    }

    return status;
}
