/*
 * lxtrap-a.0.c
 * Copyright (C) 2008-2015, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4-m.0.h>
#include <e4.h>
#include <e4fine.h>
#include <lxcall.h>
#include <lxtrap-defs.h>
#include <lxtrap-inter.h>
#include <lxtrap-types.h>
#include <nt.h>

#define screen(screen) \
    ((struct screen_type *) (screen))

extern const struct x1f4_eelookup_type _x1f4_type_lookup;

static int init_trap(struct lxtrap_type *, unsigned,
		     const struct screen_type *);
static int line_data(struct lxtrap_type *, const struct screen_type *,
		     struct lxtype_type *);
static int line_trap(struct lxtrap_type *, unsigned,
		     const struct screen_type *, void *, void **);
static int link_trap(struct lxtrap_type *, unsigned,
		     const struct screen_type *);

static void line_____(u_case_args_____0);
static void line_cfix(u_case_args_____0);
static void line_cset(u_case_args_____0);
static void line_gfar(u_case_args_____0);
static void line_sset(u_case_args_____0);
static void line_tfix(u_case_args_____0);
static void line_tset(u_case_args_____0);
static void line_umap(u_case_args_____0);
static void line_uset(u_case_args_____0);
static void line_wfix(u_case_args_____0);
static void line_wset(u_case_args_____0);

static const int c_____t__[] = {
/* *INDENT-OFF* */
    X1f4_E4_TEXT
/* *INDENT-ON* */
};
static const struct line_type slip_line[] = {
/* *INDENT-OFF* */
#define __u2call_count			4
    {	{	"__u2call",
		_libx1f4i0_lxtrap_u_forward,	X1f4_E4_VOID,
		NULL,				__u2call_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_SIDE_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						8		},
	line_uset,							},
#define __u2call_reach			(0 + __u2call_count)
#define __ucall_count			3
    {	{	"__ucall",
		_libx1f4i0_lxtrap_u_pending,	X1f4_E4_VOID,
		NULL,				__ucall_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_SIDE_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						7		},
	line_umap,							},
#define __ucall_reach			(__u2call_reach + __ucall_count)
#define call_count			1
    {	{	"call",
		_libx1f4i0_lxtrap_c_logique,	X1f4_E4_CASE,
		NULL,				call_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_SIDE_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						4		},
	line_cfix,							},
#define call_reach			(__ucall_reach + call_count)
#define call_n_count			2
    {	{	"call_n",
		_libx1f4i0_lxtrap_c_forward,	X1f4_E4_VOID,
		NULL,				call_n_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_SIDE_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						6		},
	line_cset,							},
#define call_n_reach			(call_reach + call_n_count)
#define call_s_count			5
    {	{	"call_s",
		_libx1f4i0_lxtrap_s_forward,	X1f4_E4_VOID,
		NULL,				call_s_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_SIDE_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						6		},
	line_sset,							},
#define call_s_reach			(call_n_reach + call_s_count)
#define error_count			0
    {	{	"error",
		_libx1f4i0_lxtrap_e_logique,	X1f4_E4_VOID,
		c_____t__,			1,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						5		},
	line_____,							},
#define error_reach			(call_s_reach + error_count)
#define fault_count			0
    {	{	"fault",
		_libx1f4i0_lxtrap_f_forward,	X1f4_E4_VOID,
		NULL,				0,
		X1f4_E4_KEEP_CALL,		5		},
	line_____,							},
#define fault_reach			(error_reach + fault_count)
#define final_count			0
    {	{	"final",
		_libx1f4i0_lxtrap_f_logique,	X1f4_E4_VOID,
		c_____t__,			1,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						5		},
	line_____,							},
#define final_reach			(fault_reach + final_count)
#define gcall_count			2
    {	{	"gcall",
		_libx1f4i0_lxtrap_g_sequent,	X1f4_E4_CASE,
		NULL,				gcall_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_SIDE_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						5		},
	line_gfar,							},
#define gcall_reach			(final_reach + gcall_count)
#define trap_count			1
    {	{	"trap",
		_libx1f4i0_lxtrap_t_logique,	X1f4_E4_MODE,
		NULL,				trap_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_SIDE_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						4		},
	line_tfix,							},
#define trap_reach			(gcall_reach + trap_count)
#define wrap_count			2
    {	{	"wrap",
		_libx1f4i0_lxtrap_w_logique,	X1f4_E4_MODE,
		NULL,				wrap_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_POST_TYPE | X1f4_E4_SIDE_LIST
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						4		},
	line_wfix,							},
#define wrap_reach			(trap_reach + (wrap_count << 1))
/* *INDENT-ON* */
#define slip_line_count			wrap_reach
}, soft_line[] = {
/* *INDENT-OFF* */
#define trap_d_count			(trap_count + 1)
    {	{	"trap_d",
		_libx1f4i0_lxtrap_t_forward,	X1f4_E4_MODE,
		NULL,				trap_d_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_POST_TYPE | X1f4_E4_SIDE_LIST
		| X1f4_E4_TEXT_LINK | X1f4_E4_WALK_LINK,
						6		},
	line_tset,							},
#define trap_d_reach			(0 + (trap_d_count << 1))
#define trap_q_count			trap_count
    {	{	"trap_q",
		_libx1f4i0_lxtrap_t_derived,	X1f4_E4_MODE,
		NULL,				trap_q_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_SIDE_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						6		},
	line_tfix,							},
#define trap_q_reach			(trap_d_reach + trap_q_count)
#define wrap_d_count			(wrap_count + 1)
    {	{	"wrap_d",
		_libx1f4i0_lxtrap_w_forward,	X1f4_E4_MODE,
		NULL,				wrap_d_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_POST_TYPE | X1f4_E4_SIDE_LIST
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						6		},
	line_wset,							},
#define wrap_d_reach			(trap_q_reach + (wrap_d_count << 1))
#define wrap_q_count			wrap_count
    {	{	"wrap_q",
		_libx1f4i0_lxtrap_w_derived,	X1f4_E4_MODE,
		NULL,				wrap_q_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_LINK_PASS
		| X1f4_E4_POST_TYPE | X1f4_E4_SIDE_LIST
		| X1f4_E4_SLIP_LIST | X1f4_E4_TEXT_LINK
		| X1f4_E4_WALK_LINK,
						6		},
	line_wfix,							}
#define wrap_q_reach			(wrap_d_reach + (wrap_q_count << 1))
/* *INDENT-ON* */
#define soft_line_count			wrap_q_reach
};

static int
init_trap(struct lxtrap_type *lxtrap_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;

    if (bits & CODELINK_LINK) {
	lxtrap_data->link_w = screen_data->lock_w;
    } else {
	lxtrap_data->link_w.data = NULL;
	lxtrap_data->link_w.free = _x1f4_e4_free_data;
	lxtrap_data->link_w.link = _x1f4_e4_link_data;
	lxtrap_data->link_w.mode = _x1f4_e4_mode_data;
    }

    if (bits & IMPLICIT_LINK) {
	lxtrap_data->link_p.link = screen_data->link_p.link;
	lxtrap_data->link_p.text = screen_data->link_p.text;
    } else {
	lxtrap_data->link_p.link = NULL;
	lxtrap_data->link_p.text = NULL;
    }

    if (bits & COMPOSER_LINK) {
	lxtrap_data->link_q = screen_data->link_q;
    } else {
	lxtrap_data->link_q.link = NULL;
    }

    if (bits & RESOURCE_LINK) {
	lxtrap_data->link_m = screen_data->lock_m;
    } else {
	lxtrap_data->link_m.data = NULL;
	lxtrap_data->link_m.free = _x1f4_e4_free_data;
	lxtrap_data->link_m.link = _x1f4_e4_link_data;
	lxtrap_data->link_m.mode = _x1f4_e4_mode_data;
    }

    if (bits & REPORTER_LINK) {
	lxtrap_data->link_h.call = screen_data->link_h.call;
    } else {
	lxtrap_data->link_h.call = NULL;
    }

    if (1) {
	lxtrap_data->link_v = screen_data->lock_v;
    }

    if (bits & TEXTFLAT_LINK) {
	lxtrap_data->link_e = screen_data->lock_e;
    } else {
	lxtrap_data->link_e.data = NULL;
	lxtrap_data->link_e.line = NULL;
	lxtrap_data->link_e.post = NULL;
	lxtrap_data->link_e.push = NULL;
    }

    if (bits & EELOOKUP_LINK) {
	lxtrap_data->trap_e.eelookup_data = screen_data->lock_g.eelookup_data;
    } else {
	lxtrap_data->trap_e.eelookup_data = &_x1f4_type_lookup;
    }

    status = link_trap(lxtrap_data, bits, screen_data);

    return status;
}


static int
line_data(struct lxtrap_type *lxtrap_data,
	  const struct screen_type *screen_data,
	  struct lxtype_type *lxtype_data)
{
    const struct x1f4_nodetype_type *nodetype_data;
    unsigned i;

    nodetype_data = screen_data->link_t.data;

    i = screen_data->link_t.miss;
    for (; i; i--) {
	int type;

	type = nodetype_data->code;
	if (type == X1f4_E4_TEXT) {
	    lxtype_data->lead = _libx1f4i0_lxtrap_lead_text;
	    lxtype_data->slip = _libx1f4i0_lxtrap_slip_text;

	    lxtype_data->text = lxtrap_data;
	} else {
	    lxtype_data->lead = nodetype_data->lead;
	    lxtype_data->slip = nodetype_data->slip;

	    lxtype_data->text = nodetype_data->context;
	}

	lxtype_data->type = type;

	lxtype_data++;

	nodetype_data++;
    }

    return 0;
}


static int
line_trap(struct lxtrap_type *lxtrap_data, unsigned bits,
	  const struct screen_type *screen_data, void *data, void **args)
{
    struct x1f4_linetext_type *linetext_data;

    linetext_data = data;

    if (1) {
	_libx1f4i0_lxcall_side_line
	    (lxtrap_data, bits, screen_data, &linetext_data, args,
	     sizeof(slip_line) / sizeof(struct line_type), slip_line);
    }
    if (bits & REPORTER_LINK) {
	_libx1f4i0_lxcall_side_line
	    (lxtrap_data, bits, screen_data, &linetext_data, args,
	     sizeof(soft_line) / sizeof(struct line_type), soft_line);
    }
    if (1) {
	_libx1f4i0_lxcall_zero_line(linetext_data);
    }

    return 0;
}


static int
link_trap(struct lxtrap_type *lxtrap_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;
    unsigned args_count = 0, line_count = 1, miss;
    void *data;

    {
	args_count += slip_line_count;
	line_count += sizeof(slip_line) / sizeof(struct line_type);
    }
    if (bits & REPORTER_LINK) {
	args_count += soft_line_count;
	line_count += sizeof(soft_line) / sizeof(struct line_type);
    }

    {
	miss = screen_data->link_t.miss;
    }

    status = lxtrap_data->link_w.link
	(lxtrap_data->link_w.data, &data,
	 args_count * sizeof(int) + miss * sizeof(struct lxtype_type)
	 + line_count * sizeof(struct x1f4_linetext_type));
    if (status) {
	status = LINK_ERROR;
    } else {
	void *args, *text;

	text = (struct x1f4_linetext_type *) data + line_count;
	args = (struct lxtype_type *) text + miss;

	line_data(lxtrap_data, screen_data, text);
	line_trap(lxtrap_data, bits, screen_data, data, &args);

	if (0) {
	} else {
	    lxtrap_data->link_f.data = data;
	    lxtrap_data->link_t.data = text;
	    lxtrap_data->link_t.miss = miss;
	}
    }

    return status;
}


static void
line_____(u_case_args_____1)
{
}


static void
line_cfix(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_CASE;

    *args = line;
}


static void
line_cset(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_CASE;

    *args = line;
}


static void
line_gfar(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_CASE;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
line_sset(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_CASE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
line_tfix(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_CASE;

    *args = line;
}


static void
line_tset(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_TEXT;
    *line++ = X1f4_E4_CASE;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;

    *args = line;
}


static void
line_umap(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_CASE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
line_uset(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_CASE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
line_wfix(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_SLIP;
    *line++ = X1f4_E4_CASE;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;

    *args = line;
}


static void
line_wset(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_TEXT;
    *line++ = X1f4_E4_SLIP;
    *line++ = X1f4_E4_CASE;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;

    *args = line;
}


int
x1f4_init_lxtrap(void **lxtrap, unsigned bits,
	         const struct screen_type *screen_data)
{
    int (*link)(void *, void **, unsigned), status;
    void *data, *text;

    if (bits & CODELINK_LINK) {
	data = screen_data->lock_w.data;
	link = screen_data->lock_w.link;
    } else {
	data = (void *) 0;
	link = _x1f4_e4_link_data;
    }

    status = link(data, &text, sizeof(struct lxtrap_type));
    if (status) {
	status = LINK_ERROR;
    } else {
	status = init_trap(text, bits, screen_data);
	if (status) {
	    if (bits & CODELINK_LINK) {
		screen_data->lock_w.free(data, text);
	    } else {
		_x1f4_e4_free_data(data, text);
	    }
	} else {
	    *lxtrap = text;
	}
    }

    return status;
}
