/*
 * lxtrap-inter.h
 * Copyright (C) 2008-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxtrap_inter_H__
#define __LIBx1f4_lxtrap_inter_H__

#include <e4.h>
#include <lxlong.h>
#include <lxtrap-types.h>
#include <lxwide.h>

#define _libx1f4i0_lxtrap_cfix_trap	x1f4_cfix_lxtrap
#define _libx1f4i0_lxtrap_fini_trap	x1f4_fini_lxtrap
#define _libx1f4i0_lxtrap_fset_trap	x1f4_fset_lxtrap
#define _libx1f4i0_lxtrap_init_trap	x1f4_init_lxtrap
#define _libx1f4i0_lxtrap_tile_trap	x1f4_tile_lxtrap

#define __types_lock(lxtrap) \
    (&__types_long(lxtrap)->east_1)

#define __types_long(lxtrap) \
    (&((struct lxtrap_type *) (lxtrap))->ever_d)

#define _libx1f4i0_lxtrap_stat_free(___l) \
    _libx1f4i0_lxlock_stat_free(__types_lock((___l)), 0)
#define _libx1f4i0_lxtrap_stat_land(___l, ___1, ___2) \
    _libx1f4i0_lxlock_stat_land(__types_lock((___l)), (___1), (___2))
#define _libx1f4i0_lxtrap_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_lock((___l)))
#define _libx1f4i0_lxtrap_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_lock((___l)))
#define _libx1f4i0_lxtrap_stat_zero(___l, ___1, ___2) \
    _libx1f4i0_lxlock_stat_zero(__types_lock((___l)), (___1), (___2))

extern int _libx1f4i0_lxtrap_c_forward(void *, void *, void **);
extern int _libx1f4i0_lxtrap_c_logique(void *, void *, void **);
extern int _libx1f4i0_lxtrap_cfix_trap(void *, unsigned, void *);
extern int _libx1f4i0_lxtrap_e_logique(void *, void *, void **);
extern int _libx1f4i0_lxtrap_f_forward(void *, void *, void **);
extern int _libx1f4i0_lxtrap_f_logique(void *, void *, void **);
extern int _libx1f4i0_lxtrap_fini_trap(void **);
extern int _libx1f4i0_lxtrap_fset_trap
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxtrap_g_sequent(void *, void *, void **);
extern int _libx1f4i0_lxtrap_init_trap
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxtrap_lead_text(void *, void **);
extern int _libx1f4i0_lxtrap_lock_port
    (int, void *, void *, int, struct lxtrap_type *);
extern int _libx1f4i0_lxtrap_pick_call
    (void *, int, void **, void **, void *, struct lxtrap_type *,
     struct x1f4_linetext_type *, int);
extern int _libx1f4i0_lxtrap_s_forward(void *, void *, void **);
extern int _libx1f4i0_lxtrap_slip_call
    (void *, int, void *, int, void **, void *, void **, void *,
     struct lxtrap_type *, struct x1f4_linetext_type *, int);
extern int _libx1f4i0_lxtrap_slip_text(void *, void **);
extern int _libx1f4i0_lxtrap_stat_call(void *, int, const char *, unsigned);
extern int _libx1f4i0_lxtrap_stat_cast(void *);
extern int _libx1f4i0_lxtrap_stat_fink(void *, int);
extern int _libx1f4i0_lxtrap_stat_line(void *, int, unsigned);
extern int _libx1f4i0_lxtrap_stat_list(void *, unsigned, unsigned);
extern int _libx1f4i0_lxtrap_stat_lock(void *, int, int, int);
extern int _libx1f4i0_lxtrap_stat_miss(void *, int, int);
extern int _libx1f4i0_lxtrap_stat_odds(void *);
extern int _libx1f4i0_lxtrap_stat_post(void *, int, int);
extern int _libx1f4i0_lxtrap_stat_roll(void *, const char *, unsigned);
extern int _libx1f4i0_lxtrap_stat_time(void *, unsigned, long);
extern int _libx1f4i0_lxtrap_t_derived(void *, void *, void **);
extern int _libx1f4i0_lxtrap_t_forward(void *, void *, void **);
extern int _libx1f4i0_lxtrap_t_logique(void *, void *, void **);
extern int _libx1f4i0_lxtrap_tile_trap
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxtrap_trap_call(void *, void *, void **, int);
extern int _libx1f4i0_lxtrap_u_forward(void *, void *, void **);
extern int _libx1f4i0_lxtrap_u_pending(void *, void *, void **);
extern int _libx1f4i0_lxtrap_w_derived(void *, void *, void **);
extern int _libx1f4i0_lxtrap_w_forward(void *, void *, void **);
extern int _libx1f4i0_lxtrap_w_logique(void *, void *, void **);
extern int _libx1f4i0_lxtrap_wrap_call(void *, void *, void **, int);

#endif				/* __LIBx1f4_lxtrap_inter_H__ */
