/*
 * lxxsxx-2.f.c
 * Copyright (C) 2008-2011, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxfile.h>
#include <lxport-defs.h>
#include <lxport-types.h>

#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_PORT(t)			(*((X1f4_E4_C_USER *) (t)))

#define xsport(port) \
    ((struct xsport_type *) (port))

int
_libx1f4i0_lxport_f_2xshell(void *context, void *output, void **input)
{
    int status = 0;

    do {
	struct lxport_type *lxport_data;
	struct xsport_type *xsport_data;
	unsigned bits;

	xsport_data = I_PORT(input[0]);

	lxport_data = context;

	bits = I_MODE(input[1]);

	if (bits & LOSE_OVER) {
	    void *fade;

	    fade = xsport_data->fade;
	    if (fade) {
		status = x1f4_free_lxfile
		    (lxport_data->link_l.file, fade, NULL,
		     lock_excase(xsport_data));
		if (status) {
		    break;
		} else {
		    xsport_data->fade = NULL;
		}
	    }
	}

	xsport_data->bits |= bits;
    } while (0);

    return status;
}
